#include "ti86asm.inc"



.org _asm_exec_ram

   
    ;jp ProgStart
    

clipmask       = $C182   ; Temporary byte used in ASCR
rows2put       = $C183   ; Temporary byte used in ASCR
bitmask        = $C184   ; Temporary byte used in ASCR

gun_back              =$cfba

MEM =   $8200








ProgStart:
    call _clrLCD               ; clear the screen
    call _flushallmenus        ; close any open menus
    call _runindicoff          ; turn off the run indicator
    ;ld hl,0
    ;ld (score),hl



Title:

    ld hl,title_pic               ; point to RLE picture to display
    ld de,$fc00                ; display picture in video memory
    call DispRLE          

    call Stars
    call ScreenEffect
   
   
   
Game:
 im 1               ;This fixes down-left bug 
 ld hl,$D400        ;Down + Left Patch v1.0 Kirk Meyer
 ld de,$D401        ;
 ld bc,$0100
 ld (hl),$D3
 ldir
 ld hl,int_handler
 ld de,$D3D3
 ld bc,int_end-int_handler
 ldir
 ld a,$D4
 ld i,a
 im 2
 jr donepatch

int_handler:
 ex af,af'
 ld a,($C1B4)   ;_CXCURAPP
 cp $1D
 jr c,int_ok
 cp $20
 jr nc,int_ok
 im 1
 jp $0039
int_ok:
 in a,($03)
 bit 3,a
 jp z,$0039
 res 0,a
 out ($03),a
 jp $0039
int_end:
donepatch:  
    
    
    ld a,0
    ld (done),a
    ld a,1
    ld (current_level),a
    ld hl,400
    ld (bandit_max_count),hl
    ld a,3
    ld (lives),a
    ;ld hl,0
    ;ld (score),hl
   
    
    call NewLevel  
    

Loop:
    ld a,%01111110        
    out (1),a             
    nop \ nop            
    in a,(1) 
       
    bit 1,a    
    push af
    call z,GunLeft
    pop af
    
    bit 2,a    
    push af
    call z,GunRight
    pop af
    
    bit 3,a    
    push af
    call z,GunUp
    pop af
    
    bit 0,a    
    push af
    call z,GunDown
    pop af
    
    ld a,%10111111        
    out (1),a             
    nop \ nop            
    in a,(1) 
       
    bit 6,a
    jp z,quitvali
    
    call _get_key
    cp K_SECOND
    call z,HitBandit?
loopvali:
    halt
    call Bandits
    call EraseGun
    call DrawGun
    
    ld hl,(256*58)+82    
    ld (_penCol),hl
    ld hl,lives_text
    call _vputs
       
    
    ld hl,(256*58)+64    
    ld (_penCol),hl
    ld a,'|'
    call _vputmap
    
    call CheckDeadBandits
    jp CheckBanditCounts 
loopvali2:
  
    ld a,(done)
    cp 0                ;if done=1 then game is cleared
 jp z,Loop


fin:   
    ld hl,sherif_pic               ; point to RLE picture to display
    ld de,$fc00                ; display picture in video memory
    call DispRLE         
                                  
    call Pause    
    call _clrLCD
    
    ld hl,(256*18)+48    
    ld (_penCol),hl
    ld hl,invert_text0
    call _vputs
    ld hl,(256*24)+40    
    ld (_penCol),hl
    ld hl,invert_text1
    call _vputs
    ld hl,(256*36)+53    
    ld (_penCol),hl
    ld hl,year
    call _vputs
    
    
    call Stars
    call _clrLCD
    
 jp quit1









CheckBanditCounts:              ;does bandits shoot already
    ld hl,(bandit0_count)
    ld de,0
    call _cphlde
    jp z,checkbanditcountsvali
    ld hl,(bandit1_count)
    ld de,0
    call _cphlde
    jp z,checkbanditcountsvali  
 jp loopvali2               ;if they havent shot then back
checkbanditcountsvali:      
    call InvertScreen
    call Delay
    call InvertScreen
    ld a,(lives)            
    cp 1
    jp z,Quit               ;game over? 
    dec a                   ;lives is decreased
    ld (lives),a    
    ;ld hl,(score)           ;score is also decreased
    ;ld de,2000
    ;sbc hl,de
    ;ld (score),hl
    call NewLevel
 jp loopvali2






CheckDeadBandits:
    ld a,(dead_bandits)             ;Enough bandits killed, new level
    cp 10
    ret c
    
    ld a,(current_level)
    inc a
    ld (current_level),a
        push af        
    cp 10                                ;game cleared?
    call z,Done1
        pop af
    cp 10
    jp z,checkdeadbanditsvali     ;hypp joitain kohtia yli, ettei ennen lpipsy juttua tulis mitn NewLevel juttuja
       
    ld hl,(bandit_max_count)
    ld bc,27
    sbc hl,bc
    ld (bandit_max_count),hl 
    
    call NewLevel
checkdeadbanditsvali:
 ret


Done1:
    ld a,1
    ld (done),a
 ret   


DisplayDeadBandits:
    ld a,(dead_bandits) 
   
    ld d,5           
    ld b,a   
displaydeadbanditsvali:
    ld a,d
    add a,5
    ld d,a    
    push bc
    push de        
        ld c,55    
        ld a,d        
        ld b,a   
        ld hl,MINI_BANDIT
        ld de,_textShadow+99
        call PutSprite_MSB
    pop de  
    pop bc  
 djnz displaydeadbanditsvali
        
 ret


NewLevel:
    call _clrLCD
    
    set 3,(iy+5)
    ld hl,$0000
    ld (_curRow),hl 
    ld hl,invert_text0
    call _puts

    ld hl,$0007 
    ld (_curRow),hl 
    ld hl,invert_text1
    call _puts
    res 3,(iy+5)    

    ld hl,$0503
    ld (_curRow),hl
    ld hl,leveltext
    call _puts

    ld hl,$0B03
    ld (_penCol),hl   
    ld a,(current_level)
    call DispABig
    
    call Pause
    
    
    
    ld a,(current_level)
        
   cp 1
    jp z,DrawLevel1
    cp 2
    jp z,DrawLevel1
    cp 3
    jp z,DrawLevel1
   cp 4
    jp z,DrawLevel2
    cp 5
    jp z,DrawLevel2
    cp 6
    jp z,DrawLevel2
   cp 7
    jp z,DrawLevel3
    cp 8
    jp z,DrawLevel3
    cp 9
    jp z,DrawLevel3
    
    
newlevelvali:    
    
    ld a,0
    ld (dead_bandits),a

    ld h,28
    ld l,10
    ld (gun_coords),hl
    
    call DrawGun
    call SetBandits   
    
    ld hl,(256*58)+100    
    ld (_penCol),hl
    ld a,(lives)
    call DispA
 ret

DrawLevel1:
    ld hl,Layer1               ; point to RLE picture to display
    ld de,$fc00                ; display picture in video memory
    call DispRLE               ; decode and display the picture
 jp newlevelvali

DrawLevel2:
    ld hl,juna_pic               ; point to RLE picture to display
    ld de,$fc00                ; display picture in video memory
    call DispRLE               ; decode and display the picture
 jp newlevelvali

DrawLevel3:
    ld hl,bar_pic               ; point to RLE picture to display
    ld de,$fc00                ; display picture in video memory
    call DispRLE               ; decode and display the picture
 jp newlevelvali


HitBandit?
    call HitBandit0?
    call HitBandit1?
 ret

HitBandit0?:
    ld de,(gun_coords)
    ld bc,(bandit0_coords)
         
    ld a,d                        
    add a,4
    ld d,a
    
    ld a,e
    add a,4
    ld e,a    

    ld a,b  
    cp d
    ret nc
    
    ld a,b
    add a,6              
    cp d    
    ret c

    ld a,c   
    add a,-1                  
    cp e    
    ret nc

    ld a,c                 
    add a,6      
    cp e    
    ret c

    ;call Score0

    call EraseGun
    ld bc,(bandit0_coords)     
    ld hl,ERASE 
    call PutSprite     
    call SetBandit0
    call DrawGun     
    
    
    
    ld a,(dead_bandits)
    inc a
    ld (dead_bandits),a
    call DisplayDeadBandits
 ret
 
HitBandit1?:
    ld de,(gun_coords)
    ld bc,(bandit1_coords)
         
    ld a,d                        
    add a,4
    ld d,a
    
    ld a,e
    add a,4
    ld e,a    

    ld a,b  
    cp d
    ret nc
    
    ld a,b
    add a,6              
    cp d    
    ret c

    ld a,c   
    add a,-1                  
    cp e    
    ret nc

    ld a,c                 
    add a,6      
    cp e    
    ret c

    ;call Score1
     
    call EraseGun
    ld bc,(bandit1_coords)     
    ld hl,ERASE 
    call PutSprite        
    call SetBandit1 
    call DrawGun    
    
   
    
    ld a,(dead_bandits)
    inc a
    ld (dead_bandits),a
    call DisplayDeadBandits
 ret



;Score0:
;    ld hl,400
;    ld de,(bandit0_count)
;    sbc hl,de
;    ld d,h
;    ld e,l
;    ld hl,(score)
;    add hl,de
;    ld (score),hl  
; ret

;Score1:
;    ld hl,400
;    ld de,(bandit1_count)
;    sbc hl,de
;    ld d,h
;    ld e,l
;    ld hl,(score)
;    add hl,de
;    ld (score),hl     
; ret


Bandits:    
    call Bandit0
    call Bandit1
 ret

Bandit0:
    
    
    ld hl,(bandit0_count)
    ld de,0
    call _cphlde
    ret z
    ld hl,(bandit0_count)   
    dec hl
    ld (bandit0_count),hl     
 ret
Bandit1:
    

    ld hl,(bandit1_count)
    ld de,0
    call _cphlde
    ret z
    ld hl,(bandit1_count)   
    dec hl
    ld (bandit1_count),hl     
 ret



SetBandits:   
    call SetBandit0
    call SetBandit1
 ret
 
SetBandit0:
    ld hl,(bandit0_coords)
    ld (temp_coords),hl
    call SetCoords
    ld bc,(temp_coords)
    ld (bandit0_coords),bc
        
    ld hl,BANDIT 
    call PutSprite
    ld bc,(bandit_max_count)
    ld h,b
    ld l,c
    ld (bandit0_count),hl    
 ret

SetBandit1:
    ld hl,(bandit1_coords)
    ld (temp_coords),hl
    call SetCoords
    ld bc,(temp_coords)
    ld (bandit1_coords),bc
        
    ld hl,BANDIT 
    call PutSprite
    ld bc,(bandit_max_count)
    ld h,b
    ld l,c
    ld (bandit1_count),hl    
 ret


SetCoords:
    ld a,(current_level)
    cp 1
    jp z,SetLevel1Coords
    cp 2
    jp z,SetLevel1Coords
    cp 3
    jp z,SetLevel1Coords
    cp 4
    jp z,SetLevel2Coords
    cp 5
    jp z,SetLevel2Coords
    cp 6
    jp z,SetLevel2Coords
    cp 7
    jp z,SetLevel3Coords
    cp 8
    jp z,SetLevel3Coords
    cp 9
    jp z,SetLevel3Coords
setcoordsvali:    
 ret


SetLevel1Coords:
    ld a,6
    call Random
    cp 0
    call z,SetCoords0
    cp 1
    call z,SetCoords1
    cp 2
    call z,SetCoords2
    cp 3
    call z,SetCoords3
    cp 4
    call z,SetCoords4
    cp 5
    call z,SetCoords5
 jp setcoordsvali

SetCoords0:
    ld b,13
    ld c,13
    ld (temp_coords),bc 
 ret

SetCoords1:
    ld b,88
    ld c,13
    ld (temp_coords),bc 
 ret
SetCoords2:
    ld b,18
    ld c,40
    ld (temp_coords),bc 
 ret
SetCoords3:
    ld b,50
    ld c,33
    ld (temp_coords),bc 
 ret
SetCoords4:
    ld b,82
    ld c,40
    ld (temp_coords),bc 
 ret
SetCoords5:
    ld b,108
    ld c,32
    ld (temp_coords),bc 
 ret




SetLevel2Coords:
    ld a,6
    call Random
    cp 0
    call z,SetCoords0_2
    cp 1
    call z,SetCoords1_2
    cp 2
    call z,SetCoords2_2
    cp 3
    call z,SetCoords3_2
    cp 4
    call z,SetCoords4_2
    cp 5
    call z,SetCoords5_2
 jp setcoordsvali

SetCoords0_2:
    ld b,61
    ld c,11
    ld (temp_coords),bc 
 ret

SetCoords1_2:
    ld b,97
    ld c,16
    ld (temp_coords),bc 
 ret
SetCoords2_2:
    ld b,113
    ld c,16
    ld (temp_coords),bc 
 ret
SetCoords3_2:
    ld b,17
    ld c,46
    ld (temp_coords),bc 
 ret
SetCoords4_2:
    ld b,3
    ld c,33
    ld (temp_coords),bc 
 ret
SetCoords5_2:
    ld b,95
    ld c,1
    ld (temp_coords),bc 
 ret




SetLevel3Coords:
    ld a,6
    call Random
    cp 0
    call z,SetCoords0_3
    cp 1
    call z,SetCoords1_3
    cp 2
    call z,SetCoords2_3
    cp 3
    call z,SetCoords3_3
    cp 4
    call z,SetCoords4_3
    cp 5
    call z,SetCoords5_3
 jp setcoordsvali

SetCoords0_3:
    ld b,18
    ld c,1
    ld (temp_coords),bc 
 ret

SetCoords1_3:
    ld b,50
    ld c,1
    ld (temp_coords),bc 
 ret
SetCoords2_3:
    ld b,80
    ld c,1
    ld (temp_coords),bc 
 ret
SetCoords3_3:
    ld b,45
    ld c,22
    ld (temp_coords),bc 
 ret
SetCoords4_3:
    ld b,17
    ld c,37
    ld (temp_coords),bc 
 ret
SetCoords5_3:
    ld b,112
    ld c,14
    ld (temp_coords),bc 
 ret




GunLeft:
    ld hl,(gun_coords)
    ld a,h
    cp 5
    ret c
    ;call EraseGun
    ld bc,(gun_coords)
    dec b
    ld (gun_coords),bc
    ;call DrawGun
 ret   
GunRight:
    ld hl,(gun_coords)
    ld a,h
    cp 115
    ret nc
    ;call EraseGun
    ld bc,(gun_coords)
    inc b
    ld (gun_coords),bc
    ;call DrawGun
 ret   
GunUp:
    ld hl,(gun_coords)
    ld a,l
    cp 0
    ret z
    ;call EraseGun
    ld bc,(gun_coords)
    dec c
    ld (gun_coords),bc
    ;call DrawGun
 ret    
GunDown:
    ld hl,(gun_coords)
    ld a,l
    cp 50
    ret z
    ;call EraseGun
    ld bc,(gun_coords)
    inc c
    ld (gun_coords),bc
    ;call DrawGun
 ret   


DrawGun:
    ld bc,(gun_coords)
    ld (gun_back),bc
    ld de,gun_back+2
    ld hl,AIM  
    call PutSprite_MSB
        ret

EraseGun:
    ld bc,(gun_back)
    ld hl,gun_back+2
    call PutSprite
        ret







Pause:              
    call    _get_key
    cp K_ENTER       
    jp nz,Pause
        ret             

Delay:
    ld hl,40000
delayvali: 
    dec hl   
    ld de,0
        push hl
    call _cphlde
        pop hl 
 ret z
 jr delayvali


Slow:
    ld a,(slow)
    inc a
    ld (slow),a    
    cp 255
    ret nz
    ld a,0
    ld (slow),a
        ret

InvertScreen:
    ld de,8000
    ld hl,$fc00    
inverscreenvali:
    ld a,(hl)
    cpl 
    ld (hl),a    
    inc hl
        push hl
    dec de
    ld hl,0
    call _cphlde
        pop hl
  jp nz,inverscreenvali      
 ret
 
 




Stars:    
    ld a,0
    ld (y1),a
    ld a,32
    ld (x1),a
    ld a,56
    ld (y2),a
    ld a,88
    ld (x2),a
    
    
    ld b,32
    ld c,0
    ld hl,TAHTI
    call PutSprite
    
starsvali:
    ld a,(y1)
    inc a
    ld (y1),a            
    ld b,32
    ld c,a
    ld hl,TAHTI
    call PutSprite
    
    ld a,(x1)
    inc a    
    ld (x1),a    
    ld b,a
    ld c,56
    ld hl,TAHTI
    call PutSprite
    
    ld a,(y2)
    dec a
    ld (y2),a    
    ld b,88
    ld c,a
    ld hl,TAHTI
    call PutSprite
    
    
    ld a,(x2)
    dec a    
    ld (x2),a    
    ld b,a
    ld c,0
    ld hl,TAHTI
    call PutSprite
    
    
    ld a,(x1)
    cp 88
    call z,NollaaX1
    ld a,(x2)
    cp 32
    call z,NollaaX2
    ld a,(y1)
    cp 56
    call z,NollaaY1
    ld a,(y2)
    cp 0
    call z,NollaaY2
    
    
starsvali2:          
          
    call _get_key
    cp 0
    ret nz;jp nz,Game
    
    call Slow
    
    ld a,(slow)
    cp 1
 jp nz,starsvali2
 jp starsvali
 ret

NollaaX1:    
    ld a,32
    ld (x1),a  
    
 ret

NollaaX2:    
    ld a,88
    ld (x2),a  
    
 ret

NollaaY1:    
    ld a,0
    ld (y1),a  
    
 ret

NollaaY2:    
    ld a,56
    ld (y2),a  
    
 ret
 
 


; // from ztetris, Jimmy Mrdell <mja@algonet.se>
Random:            ; Creates a random number 0 <= x < A
 push bc
 push de
 push hl
 ld b,a
 ld a,r
 add a,a
 ld hl,0
 ld d,0
 ld e,a
RMul:
 add hl,de
 djnz RMul
 ld a,h
 pop hl
 pop de
 pop bc
 ret


;A simple effects routine - scrolls the screen clear to the Right
;--By Levi Lansing--
ScreenEffect:
 ld b,128           ;b = 128 (counts # of rotations of the screen)
Start:
 push bc            ;hide b (for later) and c (not needed)

 ld hl,$FC00        ;point hl to the display memory
 ld b,64            ;b = 64 (counts rows down the screen)
loop1:
 push bc            ;hide b (for later and c (for no reason)
 ld b,16            ;b = 16 (yet another counter - across the screen)
 xor a              ;clear a (a = 0)
 rra                ;rotate a to the right one bit (clears the carry flag)
loop:
 ld a,(hl)          ;what hl points to is now in a
 rra                ;rotate a to the right one bit (bit 0 to cary flag and flag to bit 7)
 ld (hl),a          ;store a back where it came from
 inc hl             ;point hl to the next byte
 djnz loop          ;decrement b and loop if it's not zero (16 times)
 pop bc             ;restore last push
 djnz loop1         ;decrement b and loop if it's not zero (64 times)

 pop bc             ;yet again
 djnz Start         ;loop again 128 times
 ret                ;return from the program (or a call)



DispA:
 ld l,a
 ld h,0
DispHL:                 ;Displays HL [By: Matthew Shepcar]
 xor a                  ;Loads 0 into A
 ld de,-1                               ;Loads -1 into DE
 ld (_curRow),de                        ;Loads de into CurRow
 call 4A33h                             ;Calls 4A33h
 dec hl                 ;Decrease it
 jp _vputs                              ;Put on screen and return


DispABig:
 ld l,a
 ld h,0
                ;Displays HL [By: Matthew Shepcar]
 xor a                  ;Loads 0 into A
 ;ld de,-1                               ;Loads -1 into DE
 ;ld (_curRow),de                        ;Loads de into CurRow
 call 4A33h                             ;Calls 4A33h
 dec hl                 ;Decrease it
 jp _vputs                              ;Put on screen and return


Quit:
    call _clrLCD

    ld hl,$0502 
    ld (_curRow),hl 
    ld hl,game_over_text
    call _puts
quit1:    
    ;ld hl,(256*30)+40    
    ;ld (_penCol),hl
    ;ld hl,score_text
    ;call _vputs    
    
    ;ld hl,(256*40)+50     
    ;ld (_penCol),hl     
    ;ld hl,(score)     
    ;call DispHL
    
    
    call Pause
quitvali:
    call _clrScrn 
    call _homeup   
 ret



ERASE:
.db %00000000
.db %00000000
.db %00000000
.db %00000000
.db %00000000
.db %00000000
.db %00000000
.db %00000000
.db %11111111
.db %11111111
.db %11111111
.db %11111111
.db %11111111
.db %11111111
.db %11111111
.db %11111111


BANDIT:
.db %00000000
.db %00111000
.db %11111110
.db %01101100
.db %01000100
.db %00101000
.db %01010100
.db %01000100
.db %00000000
.db %00111000
.db %11111110
.db %01101100
.db %01000100
.db %00101000
.db %01010100
.db %01000100


AIM:
.db %00111000
.db %00010000
.db %10111010
.db %11101110
.db %10111010
.db %00010000
.db %00111000
.db %00000000
.db %00111000
.db %00010000
.db %10111010
.db %11101110
.db %10111010
.db %00010000
.db %00111000
.db %00000000

MINI_BANDIT:
.db %00000000
.db %00000000
.db %00000000
.db %00000000
.db %01100000
.db %11110000
.db %01100000
.db %11110000
.db %00000000
.db %00000000
.db %00000000
.db %00000000
.db %01100000
.db %11110000
.db %01100000
.db %11110000


TAHTI:
.db %00000000
.db %00011000
.db %00011000
.db %01111110
.db %01111110
.db %00111100
.db %01100110
.db %00000000




; ASCR  - Advanced Sprite Clipping Routines
;
;   by Jimmy Mrdell    970304   Last update 970803
;
; Temporary variables needed:
;  clipmask  : Byte
;  rows2put  : Byte
;  bitmask   : Byte
;
;
; PutSprite_MSB:
;  Puts an 8x8 sprite at coordinates B,C. HL should point to a bitmapped
;  sprite followed by a bitmapped mask, total 16 bytes. DE should point
;  to an a memory location where the background will be stored as a
;  bitmap (8 bytes). The sprite will be clipped.
;
; PutSprite:
;  Puts an 8x8 sprite at B,C. HL = pointer to sprite. No mask and no
;  background storage, just clipping.

    


PutSprite_MSB:      ; BC = x,y  DE = background storage  HL = sprite + mask
 ld a,c
 cp 150
 jr nc,PMSB_NoBotClip
 cp 64
 ret nc
PMSB_NoBotClip:
 push bc
 push de
 push hl
 push ix
 ld a,$FF
 ld (clipmask),a
 bit 7,b
 jr z,PMSB_CheckRightClip
 ld a,b
 cp 249
 jr c,EndPMSB
 neg
 push bc
 ld b,a
 ld a,$FF
PMSB_LeftClip:
 srl a
 djnz PMSB_LeftClip
 pop bc
 res 7,b
 dec c
 ld (clipmask),a
 jr PMSB_CheckBotClip
PMSB_CheckRightClip
 ld a,b
 sub 113
 jr c,PMSB_CheckBotClip
 push bc
 ld b,a
 inc b
 ld a,$FF
PMSB_RightClip:
 add a,a
 djnz PMSB_RightClip
 ld (clipmask),a
 pop bc
PMSB_CheckBotClip:
 ld a,8
 ld (rows2put),a
 bit 7,c
 jr nz,PMSB_CheckTopClip
 bit 6,c
 jp nz,EndMSB
 ld a,64
 sub c
 cp 8
 jr nc,PMSB_ClippingDone
 ld (rows2put),a
 jr PMSB_ClippingDone
PMSB_CheckTopClip:
 ld a,c
 cp 249
EndPMSB:
 jr c,EndMSB
 ret c
 push bc
 neg
 ld b,a
 sub 8
 neg
 ld (rows2put),a
PMSB_TopClip:
 inc hl
 inc de
 djnz PMSB_TopClip
 pop bc
 ld c,0
PMSB_ClippingDone:
 di
 push iy
 push hl
 pop iy
 push de
 pop ix
 ld a,(rows2put)
 push af
 call FIND_PIXEL
Modify_5:
 ld de,$fc00
 add hl,de
 ld (bitmask),a
 pop bc
PMSB_PutRow:
 push bc
 push hl
 ld a,(clipmask)
 ld e,a
 ld a,(iy+8)
 and e
 ld e,a      ; e = mask for this row
 ld d,0      ; d = background for this row
 ld b,8      ; b = pixels left to put
 ld c,(iy) ; c = sprite row
 inc iy
PMSB_PutCol:
 push bc
 sla d
 ld a,(bitmask)
 and (hl)
 jr z,PMSB_NPH
 inc d
PMSB_NPH:
 rlc e
 jr nc,PMSB_NextBit
 ld a,(bitmask)
 rlc c
 jr c,PMSB_BitOn    
 cpl
 and (hl)
 ld (hl),a                  
 jr PMSB_NextBit               
PMSB_BitOn:
 or (hl)                    
 ld (hl),a
PMSB_NextBit:
 ld a,(bitmask)
 rrca
 ld (bitmask),a
 jr nc,PMSB_SSB
 inc hl
PMSB_SSB:
 pop bc
 rlc c
 djnz PMSB_PutCol
 ld (ix),d
 inc ix
 pop hl
 ld de,16
 add hl,de
 pop bc
 djnz PMSB_PutRow
 pop iy
 ei
EndMSB:
 pop ix
 pop hl
 pop de
 pop bc
 ret

PutSprite:       ; BC = x,y  HL = sprite
 push bc
 push de
 push hl
 push ix
 ld a,$FF
 ld (clipmask),a
 bit 7,b
 jr z,PSC_CheckRightClip
 ld a,b
 cp 249
 jr c,EndPPS
 neg
 push bc
 ld b,a
 ld a,$FF
PSC_LeftClip:
 srl a
 djnz PSC_LeftClip
 pop bc
 res 7,b
 dec c
 ld (clipmask),a
 jr PSC_CheckBotClip
PSC_CheckRightClip
 ld a,b
 sub 113
 jr c,PSC_CheckBotClip
 push bc
 ld b,a
 inc b
 ld a,$FF
PSC_RightClip:
 add a,a
 djnz PSC_RightClip
 ld (clipmask),a
 pop bc
PSC_CheckBotClip:
 ld a,8
 ld (rows2put),a
 bit 7,c
 jr nz,PSC_CheckTopClip
 bit 6,c
 jr nz,EndPS
 ld a,64
 sub c
 cp 8
 jr nc,PSC_ClippingDone
 ld (rows2put),a
 jr PSC_ClippingDone
PSC_CheckTopClip:
 ld a,c
 cp 249
EndPPS:
 jr c,EndPS
 push bc
 neg
 ld b,a
 sub 8
 neg
 ld (rows2put),a
PSC_TopClip:
 inc hl
 inc de
 djnz PSC_TopClip
 pop bc
 ld c,0
PSC_ClippingDone:
 push hl
 pop ix
 ld a,(rows2put)
 push af
 call FIND_PIXEL
Modify_6:
 ld de,$fc00
 add hl,de
 ld d,a
 pop bc
PSC_PutRow:
 push bc
 push hl
 ld a,(clipmask)
 ld e,a
 ld b,8
 ld c,(ix)
 inc ix
PSC_PutCol:
 push bc
 rlc e
 jr nc,PSC_NextBit
 ld a,d
 rlc c
 jr c,PSC_BitOn
 cpl
 and (hl)
 ld (hl),a
 jr PSC_NextBit
PSC_BitOn:
 or (hl)
 ld (hl),a
PSC_NextBit:
 rrc d
 jr nc,PSC_SSB
 inc hl
PSC_SSB:
 pop bc
 rlc c
 djnz PSC_PutCol
 pop hl
 ld bc,16
 add hl,bc
 pop bc
 djnz PSC_PutRow
EndPS:
 pop ix
 pop hl
 pop de
 pop bc
 ret

FIND_PIXEL:
 push bc
 push de
 ld hl,ExpTable+1
 ld d,0
 ld a,b
 and $07
 ld e,a
 add hl,de
 ld e,(hl)
 ld h,d
 srl b
 srl b
 srl b
 ld a,c
 add a,a
 add a,a
 ld l,a
 add hl,hl
 add hl,hl
 ld a,e
 ld e,b
 add hl,de
 pop de
 pop bc
 ret


ExpTable:
 .db $01,$80,$40,$20,$10,$08,$04,$02,$01

sherif_pic:

 .db $91,$00,$15,$C0,$91,$00,$0E,$01,$E0,$91,$00,$0E,$01,$E0,$91,$00
 .db $0F,$C0,$91,$00,$0F,$C0,$91,$00,$0E,$01,$E0,$91,$00,$0E,$01,$E0
 .db $91,$00,$0E,$03,$F0,$91,$00,$0E,$03,$F0,$91,$00,$0E,$03,$F0,$91
 .db $00,$0E,$07,$38,$91,$00,$0E,$07,$38,$91,$00,$0E,$07,$38,$91,$00
 .db $0E,$0E,$1C,$91,$00,$0E,$0E,$1C,$91,$00,$0E,$1E,$0E,$91,$00,$05
 .db $1F,$03,$80,$91,$00,$06,$1C,$0E,$91,$00,$05,$06,$01,$80,$91,$00
 .db $06,$1C,$0E,$91,$00,$05,$06,$79,$F0,$91,$00,$06,$38,$07,$91,$00
 .db $05,$06,$CD,$98,$91,$00,$06,$38,$07,$91,$00,$05,$66,$CD,$98,$91
 .db $00,$06,$38,$07,$91,$00,$05,$66,$CD,$98,$00,$00,$18,$91,$00,$03
 .db $70,$03,$80,$00,$00,$0C,$00,$7C,$7B,$F0,$00,$00,$3C,$91,$00,$03
 .db $70,$03,$80,$00,$00,$1E,$91,$00,$06,$3F,$91,$FF,$03,$F0,$03,$91
 .db $FF,$03,$FE,$91,$00,$06,$1F,$91,$FF,$03,$E0,$01,$91,$FF,$03,$FC
 .db $91,$00,$06,$03,$91,$FF,$03,$E0,$01,$91,$FF,$03,$F0,$91,$00,$06
 .db $01,$FC,$91,$00,$06,$0F,$E0,$91,$00,$07,$7E,$1F,$91,$00,$05,$1F
 .db $80,$91,$00,$07,$1F,$88,$91,$00,$05,$7E,$91,$00,$03,$01,$E3,$C0
 .db $00,$00,$0F,$C0,$03,$AB,$B9,$70,$00,$FC,$91,$00,$04,$60,$C0,$00
 .db $00,$03,$F0,$02,$2A,$25,$40,$03,$F0,$00,$00,$F7,$F8,$60,$C0,$91
 .db $00,$03,$FC,$03,$BB,$39,$60,$0F,$C0,$00,$00,$6B,$CC,$60,$C0,$91
 .db $00,$03,$7E,$00,$AA,$29,$40,$1F,$80,$00,$00,$6B,$FC,$60,$C0,$91
 .db $00,$03,$1F,$83,$AB,$A5,$40,$7E,$91,$00,$03,$36,$C0,$60,$C0,$91
 .db $00,$03,$07,$C0,$91,$00,$03,$F8,$91,$00,$03,$36,$7D,$FB,$F0,$91
 .db $00,$03,$03,$F0,$1F,$FF,$03,$F0,$91,$00,$0B,$FC,$10,$00,$0F,$C0
 .db $91,$00,$0B,$3C,$00,$00,$0F,$91,$00,$0C,$3C,$00,$00,$0F,$91,$00
 .db $0C,$38,$00,$00,$07,$91,$00,$0C,$78,$00,$00,$07,$80,$91,$00,$0B
 .db $70,$00,$00,$03,$80,$91,$00,$03,$0E,$00,$00,$01,$80,$91,$00,$03
 .db $70,$00,$00,$03,$80,$91,$00,$03,$06,$00,$00,$01,$80,$91,$00,$03
 .db $F0,$00,$C0,$03,$C0,$91,$00,$03,$3E,$79,$F1,$E1,$80,$91,$00,$03
 .db $E0,$03,$F0,$01,$C0,$91,$00,$03,$66,$CC,$DB,$31,$80,$00,$00,$01
 .db $E0,$87,$F8,$01,$E0,$91,$00,$03,$66,$CC,$DB,$F1,$80,$00,$00,$01
 .db $E1,$1F,$FE,$01,$E0,$91,$00,$03,$66,$CC,$DB,$91,$00,$04,$01,$C6
 .db $3F,$3F,$00,$E0,$91,$00,$03,$3F,$79,$DD,$F1,$80,$00,$00,$03,$C8
 .db $FC,$0F,$C0,$F0,$91,$00,$0A,$03,$81,$F0,$03,$E0,$70,$91,$00,$0A
 .db $07,$87,$E0,$01,$F8,$78,$91,$00,$0A,$07,$9F,$80,$00,$7E,$78,$91
 .db $00,$0A,$07,$3E,$00,$00,$1F,$38,$91,$00,$0A,$0F,$F8,$00,$00,$07
 .db $FC,$91,$00,$0A,$0F,$F0,$00,$00,$03,$FC,$91,$00,$0A,$1F,$C0,$91
 .db $00,$03,$FE,$91,$00,$0A,$1F,$91,$00,$04,$3E,$91,$00,$0A,$1C,$91
 .db $00,$04,$0F,$91,$00,$0A,$78,$91,$00,$04,$07,$80,$91,$00,$09,$F0
 .db $91,$00,$04,$07,$80,$91,$00,$09,$F0,$91,$00,$04,$03,$91,$00,$0A
 .db $60,$91,$00,$1D



title_pic:

 .db $91,$00,$E6,$78,$7F,$F9,$E0,$91,$00,$0C,$78,$7F,$F9,$F8,$91,$00
 .db $0C,$30,$33,$30,$D8,$91,$00,$0C,$30,$33,$30,$D8,$91,$00,$0C,$30
 .db $33,$30,$CC,$91,$00,$0C,$37,$B3,$30,$CC,$91,$00,$0C,$37,$B3,$30
 .db $CC,$91,$00,$0C,$33,$33,$30,$D8,$91,$00,$0C,$33,$33,$36,$D8,$91
 .db $00,$0C,$0C,$C7,$BF,$F8,$91,$00,$0C,$0C,$C7,$BF,$E0,$91,$00,$2C
 .db $F0,$FF,$E7,$FF,$80,$91,$00,$0B,$F0,$FF,$EF,$FF,$80,$91,$00,$0B
 .db $60,$66,$6D,$ED,$80,$91,$00,$0B,$60,$66,$0C,$0C,$91,$00,$0C,$60
 .db $67,$8E,$0C,$91,$00,$0C,$6F,$67,$87,$0C,$91,$00,$0C,$6F,$66,$03
 .db $0C,$91,$00,$0C,$66,$66,$03,$0C,$91,$00,$0C,$66,$66,$7B,$0C,$91
 .db $00,$0C,$19,$8F,$FF,$1E,$91,$00,$0C,$19,$8F,$FE,$1E,$91,$00,$FF
 .db $91,$00,$07,$74,$EA,$80,$91,$00,$0D,$54,$AA,$80,$91,$00,$0D,$54
 .db $E4,$80,$91,$00,$0D,$76,$A4,$80,$91,$00,$10,$60,$91,$00,$0C,$57
 .db $6E,$E9,$49,$91,$00,$0C,$75,$64,$AD,$6D,$91,$00,$0C,$57,$54,$AB
 .db $4B,$91,$00,$0C,$55,$54,$E9,$69,$91,$00,$1C


;score:                    .dw 0
gun_coords              .dw 0;= MEM+2
temp_coords             .dw 0;= MEM+4
temp_count              .dw 0;= MEM+6
bandit0_coords          .dw 0;= MEM+8
bandit0_count           .dw 0;= MEM+10   ;Akseli is tough guy
bandit1_coords          .dw 0;= MEM+12
bandit1_count           .dw 0;= MEM+14

dead_bandits            .dw 0;= MEM+16

current_level           .dw 0;= MEM+18

bandit_max_count        .dw 0;= MEM+20

done                    .dw 0;= MEM+22
lives                   .dw 0;= MEM+24

y1                       .dw 0;= MEM+26
x1                       .dw 0;= MEM+28
y2                       .dw 0;= MEM+30
x2                       .dw 0;= MEM+32
slow                     .dw 0;= MEM+34



leveltext:
.db "LEVEL:",0

invert_text0:
.db "Wild West            ",0

invert_text1:
.db "Olavi Hartonen      ",0

lives_text:
.db "lives:",0

;score_text:
;.db "final score:",0

year:  
.db "2001",0

game_over_text:
.db "Game Over!",0

#include "rle.asm"      ; RLE picture displayer v1.1
                        ; Decodes a RLE picture made by RLE2PIC
                        ;
                        ; written by David Phillips <electrum@tfs.net>

#include "pics.asm"

.end
